Subject: bug#61505: closed (Re: bug#61505: [PATCH] Handle anonymous commands in C-h K)

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 10 Jan 2024 22:52:01 +0000

Your bug report

#61505: [PATCH] Handle anonymous commands in C-h K

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
61505: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=61505
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#61505: [PATCH] Handle anonymous commands in C-h K
From: Stefan Kangas <[email-masked]>
To: Eshel Yaron <[email-masked]>
Cc: [email-masked]
Date: Wed, 10 Jan 2024 14:51:31 -0800
List-Id: <debbugs-submit.debbugs.gnu.org>

Version: 30.1

Eshel Yaron <[email-masked]> writes:

> Currently C-h K (Info-goto-emacs-key-command-node) throws an error when
> used on anonymous commands, for example:
>
> 1. emacs -Q
> 2. Evaluate this form:
>     (keymap-global-set "C-c m"
>                        (lambda ()
>                          (interactive)
>                          (message "foo")))
> 3. Type C-h K C-c m
> 4. Get this error:
>     Info-goto-emacs-command-node: Wrong type argument: symbolp, (closure (t) nil (interactive) (message "foo"))
>
> This patch makes Info-goto-emacs-key-command-node detect and handle such
> cases by printing an informative message instead of calling
> Info-goto-emacs-command-node.

Thanks, makes sense to me, so I installed it on master (9eed00c8e5a).

I changed the message to be slightly more clear in a followup commit to
look like this:

    C-c m invokes an anonymous command defined with ‘lambda’

I also made it use `substitute-command-keys'.

Subject: [PATCH] Handle anonymous commands in C-h K
From: Eshel Yaron <[email-masked]>
To: [email-masked]
Date: Tue, 14 Feb 2023 09:39:00 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Tags: patch

Currently C-h K (Info-goto-emacs-key-command-node) throws an error when
used on anonymous commands, for example:

1. emacs -Q
2. Evaluate this form:
    (keymap-global-set "C-c m"
                       (lambda ()
                         (interactive)
                         (message "foo")))
3. Type C-h K C-c m
4. Get this error:
    Info-goto-emacs-command-node: Wrong type argument: symbolp, (closure (t) nil (interactive) (message "foo"))

This patch makes Info-goto-emacs-key-command-node detect and handle such
cases by printing an informative message instead of calling
Info-goto-emacs-command-node.

In GNU Emacs 30.0.50 (build 6, x86_64-apple-darwin22.2.0, NS
 appkit-2299.30 Version 13.1 (Build 22C65)) of 2023-02-11 built on
 esmac.lan
Repository revision: 838415525bd4e77a79e18af8e4f01ed004196c71
Repository branch: master
Windowing system distributor 'Apple', version 10.3.2299
System Description:  macOS 13.1

Configured using:
 'configure --with-native-compilation --with-json --with-xwidgets
 --with-mailutils --with-imagemagick --without-dbus'

>From b835e3ab3803ba0344a068dd00b2fc413c3cc970 Mon Sep 17 00:00:00 2001
From: Eshel Yaron <[email-masked]>
Date: Tue, 14 Feb 2023 09:18:37 +0200
Subject: [PATCH] Handle anonymous commands in C-h K

* lisp/info.el (Info-goto-emacs-key-command-node): Don't call
Info-goto-emacs-command-node for anonymous commands.
---
 lisp/info.el | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

diff --git a/lisp/info.el b/lisp/info.el
index 035dff66e75..cf11b782bef 100644
--- a/lisp/info.el
+++ b/lisp/info.el
@@ -4671,8 +4671,11 @@ Info-goto-emacs-key-command-node
 		(eq command 'execute-extended-command))
 	   (Info-goto-emacs-command-node
 	    (read-command "Find documentation for command: ")))
+          ((symbolp command)
+           (Info-goto-emacs-command-node command))
 	  (t
-	   (Info-goto-emacs-command-node command)))))
+	   (message "%s invokes an anonymous command"
+                    (key-description key))))))
 
 (defvar Info-link-keymap
   (let ((keymap (make-sparse-keymap)))
-- 
2.39.0